<template lang='pug'>
div.x-codemirror
  span.d-none(ref="content")
    slot
  span(v-show='!showHtml' key='editor')
    CodeMirrorEditor(v-model="content" ref="cmEditor"
      :options="cmOptions" @input="onInput")
    div.x-ctrls.m-3
      button.mx-1.btn.btn-outline-secondary.shadow(@click='onHtmlPreview(true)') html
      button.mx-1.btn.btn-outline-primary.shadow(@click='onRender()') render
  span(v-if='showHtml' key='preview')
    CodeMirrorEditor.x-html-preview(v-model="htmlPreview"
      :managedModes='[ "htmlmixed" ]' :options="cmPreviewOptions")
    div.x-ctrls.m-3
      button.mx-1.btn.btn-outline-primary.shadow(@click='onHtmlPreview(false)') edit
    BaseRibbon(value="preview")
</template>
<script>
import { CodeMirrorEditor } from "../src";
import _ from "lodash";

import axios from "axios";
/* eslint-disable-next-line @typescript-eslint/no-unused-vars */ // @ts-ignore
import HtmlMod from "codemirror/mode/htmlmixed/htmlmixed"; // jshint ignore:line

export default {
  name: "AppCodeMirror",
  components: { CodeMirrorEditor },
  codemirror: null,
  data() {
    return {
      showHtml: false,
      content: "",
      htmlContent: "",
      htmlPreview: "",
      cmOptions: {
        tabSize: 2,
        mode: "pug",
        lineNumbers: true,
        line: true
      },
      cmPreviewOptions: {
        tabSize: 2,
        mode: "htmlmixed",
        lineNumbers: true, readOnly: true,
        line: true
      }
    };
  },
  mounted() {
    this.content = this.$refs.content.innerText;
    this.onRender();
  },
  beforeDestroy() {
    this.$options.codemirror.toTextArea();
  },
  methods: {
    async render(pretty = false) {
      return axios.post(this.$butils.currentUrl() + "/pugRender", this.content,
        { headers: { "Content-Type": "text/plain" },
          params: { pretty: (pretty) ? 1 : 0 } })
      .then((res) => _.get(res, "data"));
    },
    async onRender() {
      this.htmlContent = await this.render();
      this.$emit("change", this.htmlContent);
    },
    async onHtmlPreview(show = true) {
      if (show) {
        this.htmlPreview = await this.render(true);
        this.showHtml = true;
      }
      else {
        this.htmlPreview = "";
        this.showHtml = false;
      }
    },
    onInput(val) {
      this.content = val;
    },
    refresh() {
      this.$refs.cmEditor.refresh();
    }
  }
};
</script>
<style lang="scss">
@import '../node_modules/codemirror/lib/codemirror.css';
.x-codemirror {
  .CodeMirror {
    z-index: 0;
  }

  .x-ctrls {
    bottom: 0;
    right: 0;
    position: absolute;
    z-index: 1;
  }
  .x-html-preview {
    filter: brightness(95%);
  }
}
</style>
